// pages/market/detail.js
import WxValidate from '../../utils/wxValidate'
const app = getApp()
Page({

   /**
    * 页面的初始数据
    */
   data: {
      frameStyle: { useTop: true, name: '信息管理', leftArrow: true, useBar: false },
      // 主体高度
      infoHeight: '',
      userInfo: { id: '00010102883', name: '供货单位' },
      form: {},
      // 商品类型
      typeList: [
         { code: "8", id: "61dd3480bf70154c7fa35ac5", name: "办公用品" },
         { code: "8", id: "61dd3480bf70154c7fa35ac5", name: "金融用品" },
         { code: "8", id: "61dd3480bf70154c7fa35ac5", name: "书写工具" },
         { code: "8", id: "61dd3480bf70154c7fa35ac5", name: "办公机械" },
         { code: "8", id: "61dd3480bf70154c7fa35ac5", name: "文件用品" },
         { code: "8", id: "61dd3480bf70154c7fa35ac5", name: "其他用品" },
      ],
      // 图片
      img_url: [],
   },
   initValidate() {
      const rules = { type_name: { required: true }, name: { required: true, }, brief: { required: true, }, money: { required: true, }, }
      // 验证字段的提示信息，若不传则调用默认的信息
      const messages = { type_name: { required: '请选择商品类型', }, name: { required: '请输入商品名称', }, brief: { required: '请输入商品简介', }, money: { required: '请输入商品价格', }, };
      this.WxValidate = new WxValidate(rules, messages)
   },
   back: function () {
      wx.navigateBack({ url: '/pages/market/index' })
   },
   // 类型选择
   typeChange: function (e) {
      let { value } = e.detail;
      let data = this.data.typeList[value];
      this.setData({ 'form.type_id': data.id })
      this.setData({ 'form.type_name': data.name })
   },
   // 上传图片
   imgUpl: function (e) {
      const that = this;
      let data = that.data.img_url;
      data.push(e.detail)
      that.setData({ img_url: data })
   },
   // 删除图片
   imgDel: function (e) {
      const that = this;
      let list = that.data.img_url;
      let arr = list.filter((i, index) => index != e.detail.index)
      that.setData({ img_url: arr })
   },
   // 取消保存
   onReset: function (e) {
      this.back()
   },
   // 提交保存
   onSubmit: function (e) {
      const params = e.detail.value;
      params.img_url = this.data.img_url;
      if (!this.WxValidate.checkForm(params)) {
         const error = this.WxValidate.errorList[0];
         wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
         return false
      } else {
         wx.showModal({
            title: '是否确认提交商品',
            success(res) {
               if (res.confirm) {
                  wx.showToast({ title: `提交商品成功`, icon: 'success', duration: 2000 });
               } else if (res.cancel) {
               }
            }
         })
      }
   },
   /**
    * 生命周期函数--监听页面加载
    */
   onLoad: function (options) {
      this.setData({ 'form.mech_name': this.data.userInfo.name, 'form.mech_id': this.data.userInfo.id, })
      this.watchLogin();
      //验证规则函数
      this.initValidate()
      // 计算高度
      this.searchHeight()
   },
   // 监听用户是否登录
   watchLogin: function () {
      // wx.getStorage({
      // key: 'user',
      // success: res => {
      //   if (res.data) {
      //     // 查询菜单
      //     if (res.data) this.searchRouter(res.data);
      //     res.data.type = type.find((i) => i.value == res.data.type).label;
      //     if (res.data) this.setData({ userInfo: res.data });
      //     if (res.data && res.data.avatarUrl) this.setData({ avatarUrl: res.data.avatarUrl });
      //   } else {
      //     wx.redirectTo({ url: '/pages/login/index', })
      //   }
      // }
      // })
   },
   // 计算高度
   searchHeight: function () {
      let frameStyle = this.data.frameStyle;
      let client = app.globalData.client;
      // 减去状态栏
      let infoHeight = client.windowHeight - (client.statusBarHeight + client.getMenu.height + (client.getMenu.top - client.statusBarHeight) * 2);
      // 是否减去底部菜单
      if (frameStyle.useBar) infoHeight = infoHeight - 50;
      if (infoHeight) this.setData({ infoHeight: infoHeight })
   },

   /**
    * 生命周期函数--监听页面初次渲染完成
    */
   onReady: function () {

   },

   /**
    * 生命周期函数--监听页面显示
    */
   onShow: function () {

   },

   /**
    * 生命周期函数--监听页面隐藏
    */
   onHide: function () {

   },

   /**
    * 生命周期函数--监听页面卸载
    */
   onUnload: function () {

   },

   /**
    * 页面相关事件处理函数--监听用户下拉动作
    */
   onPullDownRefresh: function () {

   },

   /**
    * 页面上拉触底事件的处理函数
    */
   onReachBottom: function () {

   },

   /**
    * 用户点击右上角分享
    */
   onShareAppMessage: function () {

   }
})
